## moonphase 0.4.1

=== CMakeLists.txt ===
#
# This file is part of moonphase.
# Copyright (C) 2014-2015 by Alan Wise (alanwise@users.sourceforge.net)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#

# CMake minimum version.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

# Project name.
PROJECT(moonphase)

# Load user preferences.
INCLUDE("${CMAKE_SOURCE_DIR}/preferences.cmake" OPTIONAL)

# Build information.
SET(MOONPHASE_MAJORVERSION "0")
SET(MOONPHASE_MINORVERSION "4")
SET(MOONPHASE_PATCHVERSION "1")
SET(MOONPHASE_DISPLAYNAME "Moon Phase")
SET(MOONPHASE_OWNER "Alan Wise")
SET(MOONPHASE_DESCRIPTION "Displays the phase of the moon in the system tray."
    " Additionally, a window can be displayed that shows user selectable data"
    " about the moon (rise/set times, percent illumination, etc).")
STRING(REPLACE ";" "" MOONPHASE_DESCRIPTION "${MOONPHASE_DESCRIPTION}")
SET(MOONPHASE_COPYRIGHTNOTICE
    "Copyright (C) 2014-2015 ${MOONPHASE_OWNER}.")
SET(MOONPHASE_WEBSITE "http://sourceforge.net/projects/moonphase/")
SET(MOONPHASE_LICENSE
    "License GPLv3: GNU GPL version 3 or later <http://gnu.org/licenses/>.")

# Convert license agreement to include file.
FILE(READ "${PROJECT_SOURCE_DIR}/COPYING" COPYING)
STRING(REGEX REPLACE "\"" "\\\\\"" ESCAPEQUOTES "${COPYING}")
STRING(REGEX REPLACE "\n" "\\\\n\"\n\"" CCODE "${ESCAPEQUOTES}")
SET(LICENSEAGREEMENT "const char f_pLicenseAgreement[]=\n\"${CCODE}\";")
FILE(WRITE
    "${CMAKE_CURRENT_BINARY_DIR}/licenseagreement.h" "${LICENSEAGREEMENT}")

# Additional compiler options and settings.
IF(UNIX)
  SET(DEFINE_PREFIX -D)
  ADD_DEFINITIONS(${DEFINE_PREFIX}_GNU_SOURCE)
      # Need this define for certain prototypes.
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=c99") # C99 for wchar_t.
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
ELSEIF(WIN32 AND MSVC)
  SET(DEFINE_PREFIX /D)
  ADD_DEFINITIONS(${DEFINE_PREFIX}_CRT_SECURE_NO_WARNINGS
      ${DEFINE_PREFIX}_CRT_NONSTDC_NO_DEPRECATE
      ${DEFINE_PREFIX}_USE_MATH_DEFINES)
ELSE()
  MESSAGE(FATAL_ERROR
      "Unknown build configuration. CMakeLists.txt needs to be updated!")
ENDIF()

# If debug mode, set debug definition.
STRING(TOLOWER "${CMAKE_BUILD_TYPE}" BUILDTYPELC)
IF("${BUILDTYPELC}" STREQUAL "debug")
  ADD_DEFINITIONS(${DEFINE_PREFIX}DEBUG)
ENDIF()

# Default to Release build type
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF()


#
# Include paths
#


#
# Sources
#


#
# Binaries
#


#
# Subdirectories
#

ADD_SUBDIRECTORY(qt/application)
ADD_SUBDIRECTORY(toolbox)


#
# Installation
#


#
# CMakeLists.txt
#

=== toolbox/CMakeLists.txt ===
#
# This file is part of toolbox.
# Copyright (C) 2008-2015 by Alan Wise (alanwise@users.sourceforge.net)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#

# CMake minimum version.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

# Project name.
PROJECT(toolbox)

# Load user preferences.
INCLUDE("${CMAKE_SOURCE_DIR}/preferences.cmake" OPTIONAL)

# Build information.
SET(TOOLBOX_MAJORVERSION "0")
SET(TOOLBOX_MINORVERSION "2")
SET(TOOLBOX_PATCHVERSION "0")
SET(TOOLBOX_DISPLAYNAME "Toolbox")
SET(TOOLBOX_OWNERNAME "Alan Wise")
SET(TOOLBOX_COPYRIGHTNOTICE
    "Copyright (C) 2008-2015 ${TOOLBOX_OWNERNAME}.")
SET(TOOLBOX_WEBSITE "http://sourceforge.net/projects/awtoolbox/")
SET(TOOLBOX_LICENSE
    "License GPLv3: GNU GPL version 3 or later <http://gnu.org/licenses/>.")

# Additional compiler options and settings.
IF(UNIX)
  SET(DEFINE_PREFIX -D)
  ADD_DEFINITIONS(-Wall)
  ADD_DEFINITIONS(-D_GNU_SOURCE) # Need this define for certain prototypes.
ELSEIF(WIN32 AND MSVC)
  SET(DEFINE_PREFIX /D)
ELSE()
  MESSAGE(FATAL_ERROR
      "Unknown build configuration. CMakeLists.txt needs to be updated!")
ENDIF()

# If debug mode, set debug definition.
STRING(TOLOWER "${CMAKE_BUILD_TYPE}" BUILDTYPELC)
IF("${BUILDTYPELC}" STREQUAL "debug")
  ADD_DEFINITIONS(${DEFINE_PREFIX}DEBUG)
ENDIF()

# Default to Release build type
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF()


#
# Include paths
#


#
# Sources
#


#
# Binaries
#


#
# Subdirectories
#

ADD_SUBDIRECTORY(generic)
ADD_SUBDIRECTORY(qt/utilities)
ADD_SUBDIRECTORY(qt/widgets)
ADD_SUBDIRECTORY(qt/designer)


#
# Installation
#


#
# CMakeLists.txt
#

=== qt/application/CMakeLists.txt ===
#
# This file is part of moonphase.
# Copyright (C) 2014-2015 by Alan Wise (alanwise@users.sourceforge.net)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


INCLUDE(ExternalProject)

# Options.
OPTION(OPTION_MOONPHASE_BUILDQTAPPLICATION
    "Build the Qt ${MOONPHASE_DISPLAYNAME} application." ON)
OPTION(OPTION_MOONPHASE_BUILDQTAPPLICATIONDOCUMENTATION
    "Build the Qt ${MOONPHASE_DISPLAYNAME} application documentation." OFF)


#
# Configuration
#

# Name and version.
SET(MOONPHASEQT_EXECUTABLENAME "${PROJECT_NAME}-qt")

IF(OPTION_MOONPHASE_BUILDQTAPPLICATION)
  # Need Qt4.
  FIND_PACKAGE(Qt4 REQUIRED QtCore QtGui QtNetwork)
  INCLUDE(${QT_USE_FILE})
  # Create a configuration file.
  CONFIGURE_FILE(
      "${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in"
      "${CMAKE_CURRENT_BINARY_DIR}/config.h")
  # Create the desktop entry
  IF(UNIX)
    CONFIGURE_FILE(
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake/${MOONPHASEQT_EXECUTABLENAME}.desktop.in"
        "${CMAKE_CURRENT_BINARY_DIR}/${MOONPHASEQT_EXECUTABLENAME}.desktop")
  ENDIF()
  # Check for debug mode.
  STRING(TOLOWER "${CMAKE_BUILD_TYPE}" BUILDTYPELC)
  IF("${BUILDTYPELC}" STREQUAL "debug")
    ADD_DEFINITIONS(-DDEBUG)
  ENDIF()
  # Additional definitions.
  IF(WIN32 AND MSVC)
    ADD_DEFINITIONS(${DEFINE_PREFIX}UNICODE)
        # Needed for qtsingleapplication (qlockedfile_win.cpp)
  ENDIF()
ENDIF()

IF(OPTION_MOONPHASE_BUILDQTAPPLICATIONDOCUMENTATION)
  # Need Doxygen.
  FIND_PACKAGE(Doxygen REQUIRED)
  # Create the Doxygen file.
  CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/cmake/Doxyfile.in"
      "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${MOONPHASEQT_EXECUTABLENAME}")
ENDIF()


#
# Include paths
#

IF(OPTION_MOONPHASE_BUILDQTAPPLICATION)
  INCLUDE_DIRECTORIES(
      "${CMAKE_BINARY_DIR}/"
      "${CMAKE_CURRENT_BINARY_DIR}/"
      "${CMAKE_BINARY_DIR}/toolbox/qt/widgets/"
      "${CMAKE_BINARY_DIR}/toolbox/qt/utilities/sources/"
      "${CMAKE_SOURCE_DIR}/toolbox/qt/widgets/sources/"
      "${CMAKE_SOURCE_DIR}/toolbox/qt/utilities/sources/"
      "${CMAKE_SOURCE_DIR}/qt/qt-solutions/qtsingleapplication/src/"
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/"
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/qwwbuttonlineedit/"
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/qwwcolorbutton/"
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/qwwfilechooser/")
ENDIF()


#
# Sources
#

IF(OPTION_MOONPHASE_BUILDQTAPPLICATION)
  INCLUDE("${CMAKE_SOURCE_DIR}/common/common.cmake")
  SET(MOONPHASEQT_SOURCES
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/${PROJECT_NAME}qt.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/controlpaneldialog.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationoptionsdialog.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationpaneldialog.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/moonanimation.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/options.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/settings.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/../qt-solutions/qtsingleapplication/src/qtlocalpeer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/../qt-solutions/qtsingleapplication/src/qtsingleapplication.cpp")
  SET(MOONPHASEQT_HEADERS
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/controlpaneldialog.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationoptionsdialog.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/sources/informationpaneldialog.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/../qt-solutions/qtsingleapplication/src/qtlocalpeer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/../qt-solutions/qtsingleapplication/src/qtsingleapplication.h")
  SET(MOONPHASEQT_FORMS
      "${CMAKE_CURRENT_SOURCE_DIR}/forms/controlpaneldialog.ui"
      "${CMAKE_CURRENT_SOURCE_DIR}/forms/informationoptionsdialog.ui"
      "${CMAKE_CURRENT_SOURCE_DIR}/forms/informationpaneldialog.ui"
      "${CMAKE_CURRENT_SOURCE_DIR}/forms/testwidget.ui")
  SET(MOONPHASEQT_RESOURCES
      "${CMAKE_CURRENT_SOURCE_DIR}/resources/${PROJECT_NAME}qt.qrc")
  QT4_WRAP_CPP(MOONPHASEQT_MOC ${MOONPHASEQT_HEADERS})
  QT4_WRAP_UI(MOONPHASEQT_UI ${MOONPHASEQT_FORMS})
  QT4_ADD_RESOURCES(MOONPHASEQT_QRC ${MOONPHASEQT_RESOURCES})
  SET(MOONPHASEQT_FILES
      ${MOONPHASEQT_SOURCES}
      ${MOONPHASEQT_MOC}
      ${MOONPHASEQT_UI}
      ${MOONPHASEQT_QRC})
  IF(WIN32)
    SET(MOONPHASEQT_FILES ${MOONPHASEQT_FILES}
        "${CMAKE_CURRENT_SOURCE_DIR}/resources/${PROJECT_NAME}qt.rc")
  ENDIF()
ENDIF()


#
# Binaries
#

IF(OPTION_MOONPHASE_BUILDQTAPPLICATION)
  # moonphase-qt depends on an external library that is built from source code.
  IF(UNIX)
    SET(CONFIGURE_COMMAND
        "${CMAKE_CURRENT_SOURCE_DIR}/../wwwidgets/cmake_configure_command_${BUILDTYPELC}")
    SET(BUILD_COMMAND "$(MAKE)")
    SET(GUI_TYPE )
    SET(WWWIDGETS_LIBRARYPATHNAME ".")
    SET(OS_LIBRARIES m)
  ELSEIF(WIN32 AND MSVC)
    SET(CONFIGURE_COMMAND
        "${CMAKE_CURRENT_SOURCE_DIR}/../wwwidgets/cmake_configure_command_${BUILDTYPELC}.bat")
    SET(BUILD_COMMAND nmake)
    SET(GUI_TYPE WIN32)
    SET(WWWIDGETS_LIBRARYPATHNAME "${BUILDTYPELC}")
    SET(OS_LIBRARIES imm32.lib winmm.lib ws2_32.lib ${QT_QTMAIN_LIBRARY})
  ELSE()
    MESSAGE(FATAL_ERROR
        "Unknown build configuration. CMakeLists.txt needs to be updated!")
  ENDIF()
  SET(WWWIDGETS_LIBRARYPATHNAME
      "${WWWIDGETS_LIBRARYPATHNAME}/${CMAKE_STATIC_LIBRARY_PREFIX}wwwidgets4")
  IF(WIN32 AND MSVC)
    IF("${BUILDTYPELC}" STREQUAL "debug")
      SET(WWWIDGETS_LIBRARYPATHNAME "${WWWIDGETS_LIBRARYPATHNAME}d")
    ENDIF()
  ENDIF()
  SET(WWWIDGETS_LIBRARYPATHNAME "${WWWIDGETS_LIBRARYPATHNAME}${CMAKE_STATIC_LIBRARY_SUFFIX}")
  EXTERNALPROJECT_ADD(wwwidgets
      URL "http://www.wysota.eu.org/wwwidgets/wwWidgets-1.0.tar.gz"
      URL_HASH MD5=e8f8cbe75ee409f18ba44f786bcc438c
      DOWNLOAD_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../wwwidgets/"
      SOURCE_DIR "${CMAKE_BINARY_DIR}/wwwidgets/"
      BINARY_DIR "${CMAKE_BINARY_DIR}/wwwidgets/"
      PATCH_COMMAND ""
      CONFIGURE_COMMAND ${CONFIGURE_COMMAND}
      BUILD_COMMAND ${BUILD_COMMAND}
      INSTALL_COMMAND "")

  # Create the executable
  ADD_EXECUTABLE(
      ${MOONPHASEQT_EXECUTABLENAME} ${GUI_TYPE}
      ${COMMON_FILES}
      ${MOONPHASEQT_FILES})
  TARGET_LINK_LIBRARIES(
      ${MOONPHASEQT_EXECUTABLENAME}
      toolboxgeneric
      toolboxqtutilities
      toolboxqtwidgets
      "${CMAKE_BINARY_DIR}/wwwidgets/widgets/${WWWIDGETS_LIBRARYPATHNAME}"
      ${OS_LIBRARIES}
      ${QT_LIBRARIES})
  ADD_DEPENDENCIES(${MOONPHASEQT_EXECUTABLENAME} wwwidgets)

  # Set up for cpack.
  IF(WIN32)
    # Build using nmake. DOESN'T WORK!
    SET(CPACK_CMAKE_GENERATOR "NMake Makefiles")

    # Package in an NSIS installer. DOESN'T WORK!
    SET(CPACK_GENERATOR "NSIS")

    # Options for the NSIS generator.
    INCLUDE("${CMAKE_CURRENT_LIST_DIR}/windows/nsis.cmake")
    #SET(CPACK_PROJECT_CONFIG_FILE "${CMAKE_SOURCE_DIR}/windows/nsis.cmake")
      # Crashes cpack under Windows XP.

    INCLUDE(CPack)
  ENDIF()
ENDIF()

# Build the library documentation.
IF(OPTION_MOONPHASE_BUILDQTAPPLICATIONDOCUMENTATION)
  ADD_CUSTOM_TARGET(doc-${MOONPHASEQT_EXECUTABLENAME} ALL
      COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${MOONPHASEQT_EXECUTABLENAME}"
      SOURCES "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${MOONPHASEQT_EXECUTABLENAME}")
ENDIF()


#
# Subdirectories
#


#
# Installation
#

IF(OPTION_MOONPHASE_BUILDQTAPPLICATION)
  # Install information.
  IF(UNIX)
    SET(INSTALL_BINARYDIRECTORY "bin")
    SET(INSTALL_IMAGEDIRECTORY "share/${MOONPHASEQT_EXECUTABLENAME}")
  ELSEIF(WIN32 AND MSVC)
    SET(INSTALL_BINARYDIRECTORY ".")
    SET(INSTALL_IMAGEDIRECTORY ".")
  ELSE()
    MESSAGE(FATAL_ERROR
        "Unknown build configuration. CMakeLists.txt needs to be updated!")
  ENDIF()
  # Install executable.
  INSTALL(TARGETS "${MOONPHASEQT_EXECUTABLENAME}" RUNTIME
      DESTINATION ${INSTALL_BINARYDIRECTORY})
  # Install any images.
  FILE(GLOB MOONPHASE_IMAGES "${CMAKE_SOURCE_DIR}/images/*")
  INSTALL(FILES ${MOONPHASE_IMAGES} DESTINATION ${INSTALL_IMAGEDIRECTORY})
  IF(UNIX)
    # Install an icon.
    INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/resources/${MOONPHASEQT_EXECUTABLENAME}.xpm"
        DESTINATION share/icons)
    # Install the desktop file.
    INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/${MOONPHASEQT_EXECUTABLENAME}.desktop"
        DESTINATION share/applications)
  ENDIF()
  IF(WIN32)
    # Install README
    INSTALL(FILES "${CMAKE_CURRENT_SOURCE_DIR}/windows/README.txt"
        DESTINATION .)
  ENDIF()
ENDIF()


#
# CMakeLists.txt
#

=== toolbox/generic/CMakeLists.txt ===
#
# This file is part of toolbox.
# Copyright (C) 2008-2015 by Alan Wise (alanwise@users.sourceforge.net)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


# Options.
OPTION(OPTION_TOOLBOX_BUILDGENERICLIBRARY 
    "Build the ${TOOLBOX_DISPLAYNAME} generic library." ON)
OPTION(OPTION_TOOLBOX_BUILDGENERICLIBRARYDOCUMENTATION
    "Build the ${TOOLBOX_DISPLAYNAME} generic library documentation." OFF)


#
# Configuration
#

# Subproject name.
SET(SUBPROJECTNAME "${PROJECT_NAME}generic")
SET(TOOLBOXGENERIC_DESCRIPTION
    "A generic collection of code and data which can be used across multiple projects.")

IF(OPTION_TOOLBOX_BUILDGENERICLIBRARY)
  SET(CMAKE_MODULE_PATH 
      ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_LIST_DIR}/cmake/Modules/")
  FIND_PACKAGE(MHASH)
  IF(MHASH_FOUND)
    ADD_DEFINITIONS(${DEFINE_PREFIX}USE_MHASH)
  ELSE()
    MESSAGE(WARNING "Mhash library not found! Checksum module will not be built.")
  ENDIF()
ENDIF()

IF(OPTION_TOOLBOX_BUILDGENERICLIBRARYDOCUMENTATION)
  # Need Doxygen.
  IF(NOT DOXYGEN_FOUND)
    FIND_PACKAGE(Doxygen REQUIRED)
  ENDIF()
  # Create the Doxygen file.
  CONFIGURE_FILE("${CMAKE_CURRENT_LIST_DIR}/cmake/Doxyfile.in"
      "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}")
ENDIF()


#
# Include paths
#


#
# Sources
#

IF(OPTION_TOOLBOX_BUILDGENERICLIBRARY)
  SET(TOOLBOXGENERIC_SOURCES
      ${CMAKE_CURRENT_LIST_DIR}/sources/debuglog.c
      ${CMAKE_CURRENT_LIST_DIR}/sources/file.c
      ${CMAKE_CURRENT_LIST_DIR}/sources/messagelog.c
      ${CMAKE_CURRENT_LIST_DIR}/sources/pathnamelist.c
      ${CMAKE_CURRENT_LIST_DIR}/sources/utility.c
      ${CMAKE_CURRENT_LIST_DIR}/sources/versionstring.c
      ${CMAKE_CURRENT_LIST_DIR}/sources/visualstudio.c)
  IF(MHASH_FOUND)
    SET(TOOLBOXGENERIC_SOURCES ${TOOLBOXGENERIC_SOURCES}
        ${CMAKE_CURRENT_LIST_DIR}/sources/checksum.c)
  ENDIF()
ENDIF()


#
# Binaries
#

IF(OPTION_TOOLBOX_BUILDGENERICLIBRARY)
  # Create the library.
  ADD_LIBRARY(${SUBPROJECTNAME} STATIC
      ${TOOLBOXGENERIC_SOURCES})# ${MHASH_LIBRARIES})
ENDIF()

# Build the library documentation.
IF(OPTION_TOOLBOX_BUILDGENERICLIBRARYDOCUMENTATION)
  ADD_CUSTOM_TARGET(doc-${SUBPROJECTNAME} ALL
      COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}"
      SOURCES "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}")
ENDIF()


#
# Subdirectories
#


#
# Installation
#


#
# CMakeLists.txt
#

=== toolbox/qt/designer/CMakeLists.txt ===
#
# This file is part of toolbox.
# Copyright (C) 2008-2015 by Alan Wise (alanwise@users.sourceforge.net)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

INCLUDE(CMakeDependentOption)

# Only allow build in Release version.
STRING(TOLOWER "${CMAKE_BUILD_TYPE}" BUILDTYPELC)
IF("${BUILDTYPELC}" STREQUAL "release")
  SET(BUILDRELEASEFLAG ON)
ELSE()
  SET(BUILDRELEASEFLAG OFF)
ENDIF()

# Options.
CMAKE_DEPENDENT_OPTION(OPTION_TOOLBOX_BUILDQTDESIGNERPLUGIN
    "Build the ${TOOLBOX_DISPLAYNAME} Qt Designer plugin." OFF
    "BUILDRELEASEFLAG" OFF)
OPTION(OPTION_TOOLBOX_BUILDQTDESIGNERPLUGINDOCUMENTATION
    "Build the ${TOOLBOX_DISPLAYNAME} Qt Designer plugin documentation.")


#
# Configuration
#

# Subproject name.
SET(SUBPROJECTNAME "${PROJECT_NAME}designer")

IF(OPTION_TOOLBOX_BUILDQTDESIGNERPLUGIN)
  # Need Qt4.
  IF(NOT QT4_FOUND)
    FIND_PACKAGE(Qt4 REQUIRED)
    INCLUDE(${QT_USE_FILE})
  ENDIF()

  ADD_DEFINITIONS(${DEFINE_PREFIX}BUILD_PLUGIN)
ENDIF()

IF(OPTION_TOOLBOX_BUILDQTDESIGNERPLUGINDOCUMENTATION)
  # Need Doxygen.
  IF(NOT DOXYGEN_FOUND)
    FIND_PACKAGE(Doxygen REQUIRED)
  ENDIF()
  # Create the Doxygen file.
  CONFIGURE_FILE("${CMAKE_CURRENT_LIST_DIR}/cmake/Doxyfile.in"
      "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}")
ENDIF()


#
# Include paths
#

IF(OPTION_TOOLBOX_BUILDQTDESIGNERPLUGIN)
  INCLUDE_DIRECTORIES("${QT_QTDESIGNER_INCLUDE_DIR}")
ENDIF()


#
# Sources
#

IF(OPTION_TOOLBOX_BUILDQTDESIGNERPLUGIN)
  INCLUDE("${CMAKE_CURRENT_LIST_DIR}/../widgets/toolboxqtwidgets.cmake")
  SET(TOOLBOXQTDESIGNERPLUGIN_SOURCES
      "${CMAKE_CURRENT_LIST_DIR}/sources/aboutwidgetplugin.cpp"
      "${CMAKE_CURRENT_LIST_DIR}/sources/debuglogviewerwidgetplugin.cpp"
      "${CMAKE_CURRENT_LIST_DIR}/sources/messagelogviewerwidgetplugin.cpp"
      "${CMAKE_CURRENT_LIST_DIR}/sources/toolboxwidgetsinterface.cpp")
  SET(TOOLBOXQTDESIGNERPLUGIN_HEADERS
      "${CMAKE_CURRENT_LIST_DIR}/sources/aboutwidgetplugin.h"
      "${CMAKE_CURRENT_LIST_DIR}/sources/debuglogviewerwidgetplugin.h"
      "${CMAKE_CURRENT_LIST_DIR}/sources/messagelogviewerwidgetplugin.h"
      "${CMAKE_CURRENT_LIST_DIR}/sources/toolboxwidgetsinterface.h")
  SET(TOOLBOXQTDESIGNERPLUGIN_FORMS )
  SET(TOOLBOXQTDESIGNERPLUGIN_RESOURCES )
  QT4_WRAP_CPP(TOOLBOXQTDESIGNERPLUGIN_MOC ${TOOLBOXQTDESIGNERPLUGIN_HEADERS})
  QT4_WRAP_UI(TOOLBOXQTDESIGNERPLUGIN_UI ${TOOLBOXQTDESIGNERPLUGIN_FORMS})
  QT4_ADD_RESOURCES(TOOLBOXQTDESIGNERPLUGIN_QRC ${TOOLBOXQTDESIGNERPLUGIN_RESOURCES})
  SET(TOOLBOXQTDESIGNERPLUGIN_FILES
      ${TOOLBOXQTDESIGNERPLUGIN_SOURCES}
      ${TOOLBOXQTDESIGNERPLUGIN_HEADERS}
      ${TOOLBOXQTDESIGNERPLUGIN_MOC}
      ${TOOLBOXQTDESIGNERPLUGIN_UI}
      ${TOOLBOXQTDESIGNERPLUGIN_QRC})
ENDIF()


#
# Binaries
#

IF(OPTION_TOOLBOX_BUILDQTDESIGNERPLUGIN)
  # Create the library.
  ADD_LIBRARY(${PROJECT_NAME} SHARED
      ${TOOLBOXQTWIDGETS_FILES}
      ${TOOLBOXQTDESIGNERPLUGIN_FILES})
  # Anything undefined causes an error.
  TARGET_LINK_LIBRARIES(${PROJECT_NAME} "-Wl,-z,defs" QtCore QtGui)
ENDIF()

# Build the library documentation.
IF(OPTION_TOOLBOX_BUILDQTDESIGNERPLUGINDOCUMENTATION)
  ADD_CUSTOM_TARGET(doc-${SUBPROJECTNAME} ALL
      COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}"
      SOURCES "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}")
ENDIF()


#
# Subdirectories
#


#
# Installation
#

IF(OPTION_TOOLBOX_BUILDQTDESIGNERPLUGIN)
  INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/lib${PROJECT_NAME}.so"
      DESTINATION "${QT_PLUGINS_DIR}/designer/")
ENDIF()


#
# CMakeLists.txt
#

=== toolbox/qt/utilities/CMakeLists.txt ===
#
# This file is part of toolbox.
# Copyright (C) 2008-2015 by Alan Wise (alanwise@users.sourceforge.net)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

# Options.
OPTION(OPTION_TOOLBOX_BUILDQTUTILITIESLIBRARY
    "Build the ${TOOLBOX_DISPLAYNAME} Qt Utilities library." ON)
OPTION(OPTION_TOOLBOX_BUILDQTUTILITIESLIBRARYDOCUMENTATION
    "Build the ${TOOLBOX_DISPLAYNAME} Qt Utilities library documentation." OFF)


#
# Configuration
#

# Subproject name.
SET(SUBPROJECTNAME ${PROJECT_NAME}qtutilities)
SET(TOOLBOXQTUTILITIES_DESCRIPTION
    "A Qt specific collection of code and data which can be used across multiple projects.")

IF(OPTION_TOOLBOX_BUILDQTUTILITIESLIBRARY)
  # Need Qt4.
  IF(NOT QT4_FOUND)
    FIND_PACKAGE(Qt4 REQUIRED QtCore QtNetwork)
    INCLUDE(${QT_USE_FILE})
  ENDIF()
ENDIF()

IF(OPTION_TOOLBOX_BUILDQTUTILITIESLIBRARYDOCUMENTATION)
  # Need Doxygen.
  IF(NOT DOXYGEN_FOUND)
    FIND_PACKAGE(Doxygen REQUIRED)
  ENDIF()
  # Create the Doxygen file.
  CONFIGURE_FILE("${CMAKE_CURRENT_LIST_DIR}/cmake/Doxyfile.in"
      "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}")
ENDIF()


#
# Include paths
#

INCLUDE_DIRECTORIES(
#    "${CMAKE_CURRENT_BINARY_DIR}"
    "${PROJECT_SOURCE_DIR}/generic/sources/")
#    "${PROJECT_SOURCE_DIR}/qt/widgets/sources/")


#
# Sources
#

IF(OPTION_TOOLBOX_BUILDQTUTILITIESLIBRARY)
  SET(TOOLBOXQTUTILITIES_SOURCES
      "${CMAKE_CURRENT_LIST_DIR}/sources/updatenotifier.cpp")
  SET(TOOLBOXQTUTILITIES_HEADERS
      "${CMAKE_CURRENT_LIST_DIR}/sources/updatenotifier.h")
  SET(TOOLBOXQTUTILITIES_FORMS )
  SET(TOOLBOXQTUTILITIES_RESOURCES )
  QT4_WRAP_CPP(TOOLBOXQTUTILITIES_MOC ${TOOLBOXQTUTILITIES_HEADERS})
  QT4_WRAP_UI(TOOLBOXQTUTILITIES_UI ${TOOLBOXQTUTILITIES_FORMS})
  QT4_ADD_RESOURCES(TOOLBOXQTUTILITIES_QRC ${TOOLBOXQTUTILITIES_RESOURCES})
  SET(TOOLBOXQTUTILITIES_FILES
      ${TOOLBOXQTUTILITIES_SOURCES}
      ${TOOLBOXQTUTILITIES_HEADERS}
      ${TOOLBOXQTUTILITIES_MOC}
      ${TOOLBOXQTUTILITIES_UI}
      ${TOOLBOXQTUTILITIES_QRC})
ENDIF()


#
# Binaries
#

IF(OPTION_TOOLBOX_BUILDQTUTILITIESLIBRARY)
  # Create the library.
  ADD_LIBRARY(${SUBPROJECTNAME} STATIC
      ${TOOLBOXQTUTILITIES_FILES})
ENDIF()

# Build the library documentation.
IF(OPTION_TOOLBOX_BUILDQTUTILITIESLIBRARYDOCUMENTATION)
  ADD_CUSTOM_TARGET(doc-${SUBPROJECTNAME} ALL
      COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}"
      SOURCES "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}")
ENDIF()


#
# Subdirectories
#


#
# Installation
#


#
# CMakeLists.txt
#

=== toolbox/qt/widgets/CMakeLists.txt ===
#
# This file is part of toolbox.
# Copyright (C) 2008-2015 by Alan Wise (alanwise@users.sourceforge.net)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

# Options.
OPTION(OPTION_TOOLBOX_BUILDQTWIDGETSLIBRARY
    "Build the ${TOOLBOX_DISPLAYNAME} Qt widgets library." ON)
OPTION(OPTION_TOOLBOX_BUILDQTWIDGETSLIBRARYDOCUMENTATION
    "Build the ${TOOLBOX_DISPLAYNAME} Qt widgets library documentation." OFF)


#
# Configuration
#

# Subproject name.
SET(SUBPROJECTNAME ${PROJECT_NAME}qtwidgets)
SET(TOOLBOXQTWIDGETS_DESCRIPTION
    "A Qt specific collection of code and data which can be used across multiple projects.")

IF(OPTION_TOOLBOX_BUILDQTWIDGETSLIBRARY)
  # Need Qt4.
  IF(NOT QT4_FOUND)
    FIND_PACKAGE(Qt4 REQUIRED)
    INCLUDE(${QT_USE_FILE})
  ENDIF()
ENDIF()

IF(OPTION_TOOLBOX_BUILDQTWIDGETSLIBRARYDOCUMENTATION)
  # Need Doxygen.
  IF(NOT DOXYGEN_FOUND)
    FIND_PACKAGE(Doxygen REQUIRED)
  ENDIF()
  # Create the Doxygen file.
  CONFIGURE_FILE("${CMAKE_CURRENT_LIST_DIR}/cmake/Doxyfile.in"
      "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}")
ENDIF()


#
# Include paths
#


#
# Sources
#

IF(OPTION_TOOLBOX_BUILDQTWIDGETSLIBRARY)
  INCLUDE("${CMAKE_CURRENT_LIST_DIR}/toolboxqtwidgets.cmake")
ENDIF()

#
# Binaries
#

IF(OPTION_TOOLBOX_BUILDQTWIDGETSLIBRARY)
  # Create the library.
  ADD_LIBRARY(${SUBPROJECTNAME} STATIC
      ${TOOLBOXQTWIDGETS_FILES})
ENDIF()

# Build the library documentation.
IF(OPTION_TOOLBOX_BUILDQTWIDGETSLIBRARYDOCUMENTATION)
  ADD_CUSTOM_TARGET(doc-${SUBPROJECTNAME} ALL
      COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}"
      SOURCES "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile-${SUBPROJECTNAME}")
ENDIF()


#
# Subdirectories
#


#
# Installation
#


#
# CMakeLists.txt
#

=== debian/changelog ===
moonphase (0.4.1-1mx17+1) mx; urgency=medium

  * Repackaged for MX Linux.

 -- Mike Purtell <mandbx@sbcglobal.net>  Mon, 11 Dec 2017 15:59:14 -0800

moonphase (0.4.1-1mx15+1) mx; urgency=medium

  * Rebuild for MX-15.
  * debian/control: add libqt4-dev build-depend.
  * debian/copyright: add info for wwwidgets.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 13 Nov 2016 12:39:40 -0800

moonphase (0.4.1-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Tue, 29 Dec 2015 19:00:00 -0700

moonphase (0.4.0-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Mon, 14 Dec 2015 14:05:00 -0700

moonphase (0.3.2-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Wed, 19 Aug 2015 13:35:00 -0700

moonphase (0.3.1-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Sun, 16 Aug 2015 14:35:00 -0700

moonphase (0.2.3-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Tue, 14 Oct 2014 19:12:00 -0700

moonphase (0.2.2-2) unstable; urgency=low

  * Corrected email address (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Fri,  5 Sep 2014 15:08:00 -0700

moonphase (0.2.2-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Thu,  4 Sep 2014 11:10:00 -0700

moonphase (0.2.1-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Thu, 31 Jul 2014 23:43:00 -0700

moonphase (0.2.0-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Mon, 21 Jul 2014 16:24:19 -0700

=== debian/control ===
Source: moonphase
Section: x11
Priority: optional
Maintainer: Mike Purtell (mmikeinsantarosa) <maintainer@mepiscommunity.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: Alan Wise <alanwise@users.sourceforge.net>
Build-Depends: debhelper (>= 8.0.0),
 cmake (>= 2.8),
 libqt4-dev
Standards-Version: 3.9.4
Homepage: http://moonphase.sourceforge.net/
Vcs-Git: git://git.code.sf.net/p/moonphase/code
#Vcs-Browser: http://sourceforge.net/p/moonphase/code/ci/master/tree/

Package: moonphase-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Displays the phase of the moon in the system tray.
 Displays the phase of the moon in the system tray. Additionally, a window
 can be displayed that shows user selectable data about the moon
 (rise/set times, percent illumination, etc).
